// $Id: DemoApp.java,v 1.2 2003/10/07 21:46:07 idgay Exp $

/*									tab:4
 * "Copyright (c) 2000-2003 The Regents of the University  of California.  
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *    
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Copyright (c) 2002-2003 Intel Corporation
 * All rights reserved.
 *
 * This file is distributed under the terms in the attached INTEL-LICENSE     
 * file. If you do not find these files, copies can be found by writing to
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300, Berkeley, CA, 
 * 94704.  Attention:  Intel License Inquiry.
 */
package net.tinyos.tinydb;
import net.tinyos.tinydb.parser.*;
import java.util.*;
import java.io.*;

/** 
    Simple standalone demo application to run a 
    query and print out the results.  
*/

public class DataLogger implements ResultListener{
	
	private static String queryString = "select nodeid, light from sensors ", samplePeriodString = " 2048 ",parameterString = "-vmnet";
	private static boolean isTest = true;
	
	public DataLogger() {
	try {
	    //initialize
		
		if (parameterString.equals("-vmnet")) 		
		{	
//		System.out.println("VMNet starts....");
System.out.println(queryString);
	    	TinyDBMain.initMain(0);
			}
		else if(parameterString.equals("-sim")) 		
			TinyDBMain.initMain(1);
		else if(parameterString.equals("-debug")) 		
			TinyDBMain.initMain(2);
		else TinyDBMain.initMain(3);
	   // System.out.println(queryString);   
	    //parse the query
	    q = SensorQueryer.translateQuery(queryString, (byte)1);
	    
	    //inject the query, registering ourselves as a listener for result
	    //System.out.println("Sending query.");
	    TinyDBMain.injectQuery( q, this);

	} catch (IOException e) {
	    System.out.println("Network error.");
	    System.exit(1);
	} catch (ParseException e) {
	    System.out.println("Invalid Query.");
	    System.exit(1);
	}


    }
    
    /* ResultListenr method called whenever a result arrives */
    public void addResult(QueryResult qr) {
    {
	String sensortimestamp;
	
	Vector v = qr.resultVector();

    
    Calendar currentCalendar = Calendar.getInstance(); 
    
    sensortimestamp = String.valueOf(currentCalendar.get(Calendar.YEAR))
                            + "-" + String.valueOf(currentCalendar.get(Calendar.MONTH) + 1) + "-" 
                            + String.valueOf(currentCalendar.get(Calendar.DAY_OF_MONTH)) + " " 
                            + String.valueOf(currentCalendar.get(Calendar.HOUR)) + ":" 
                            + String.valueOf(currentCalendar.get(Calendar.MINUTE)) + ":" 
                            + String.valueOf(currentCalendar.get(Calendar.SECOND));
    System.out.print(sensortimestamp + "\t");
	System.out.print(System.currentTimeMillis() + "\t");
	
	//print the result
	for (int i = 0; i < v.size(); i++) {
	    System.out.print("\t" + v.elementAt(i) + "\t|");
	}
	System.out.println();
}
    }

    public static void main(String argv[]) {
	
	     if (argv.length > 3)
	       {
	       	 System.out.println("Usage: java net.tinyos.tinydb.DataLogger query_string sample_period");
	       	 System.exit(1);
	       }
	     if (argv.length > 0) 
	       queryString = argv[0];
		 if (argv.length>1)
		  parameterString = argv[1];		   
	     if (argv.length > 2)
	       samplePeriodString = argv[2];

	       
	     queryString += " sample period " + samplePeriodString;
	     
	     new DataLogger();
    }
    
    TinyDBQuery q;
}
